<?php
class ControllerModuleAmocrmIntegration extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/amocrm_integration');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('sale/amocrm_integration');
		$this->load->model('setting/setting');

		$data['tab'] = isset($this->request->get['tab']) ? $this->request->get['tab'] : 'tab-header';

		if (($this->request->server['REQUEST_METHOD'] == 'POST') and $this->validate()) {

			if(isset($this->request->get['refresh'])){
				$this->request->post['amocrm_integration']['amo_data'] = $this->getAmoCF();
			}else{
				$this->request->post['amocrm_integration']['amo_data'] = $this->config->get('amocrm_integration')['amo_data'];
			}

			$this->model_setting_setting->editSetting('amocrm_integration', $this->request->post);		
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('module/amocrm_integration', 'token=' . $this->session->data['token'] . '&tab='.$data['tab'], true));

		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['select_cat'] = $this->language->get('select_cat');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/amocrm_integration', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => ' <i class="fa fa-shopping-cart" aria-hidden="true"></i> Оплатить подписку',
			'href' => 'https://devamo.ru/opencart/payurl?url='.$_SERVER['HTTP_HOST']
		);
		
		$data['action'] = str_replace('&amp;', '&', $this->url->link('module/amocrm_integration', 'token=' . $this->session->data['token'], true));
		$data['token'] = $this->session->data['token'];
		$data['cancel'] = $this->url->link('extension', 'token=' . $this->session->data['token'] . '&type=module', true);
		$note_template = 'ФИО: {{firstname}} {{lastname}}'.PHP_EOL;
		$note_template .= 'Email: {{email}}'.PHP_EOL;
		$note_template .= 'Телефон: {{telephone}}'.PHP_EOL . PHP_EOL;
		$note_template .= 'Платежный адрес: {{payment_country}}, {{payment_postcode}}, {{payment_city}}, {{payment_zone}}, {{payment_address_1}}, {{payment_address_2}}'.PHP_EOL . PHP_EOL;
		$note_template .= 'Адрес доставки: {{shipping_country}}, {{shipping_postcode}}, {{shipping_city}}, {{shipping_zone}}, {{shipping_address_1}}, {{shipping_address_2}}'.PHP_EOL . PHP_EOL;
		$note_template .= 'Комментарий: {{comment}}' . PHP_EOL . PHP_EOL;
		$order_page = isset($this->request->get['page']) ? $this->request->get['page'] : 1;

		$filter_data = [
			'order' => 'ASC',
			'start' => ($order_page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin'),
			'sort' => 'o.order_id',
		];

		$order_total = $this->model_sale_amocrm_integration->getTotalOrders($filter_data);
		$orders = $this->model_sale_amocrm_integration->getOrders($filter_data);
		$pagination = new Pagination();
		$pagination->total = $order_total;
		$pagination->page = $order_page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('extension/module/amocrm_integration', 'token=' . $this->session->data['token'] . '&page={page}', true);

		$data['pagination'] = $pagination->render();
		$data['results'] = sprintf($this->language->get('text_pagination'), ($order_total) ? (($order_page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($order_page - 1) * $this->config->get('config_limit_admin')) > ($order_total - $this->config->get('config_limit_admin'))) ? $order_total : ((($order_page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $order_total, ceil($order_total / $this->config->get('config_limit_admin')));


		$last_order = $this->getOrder($orders['0']['order_id']);

		if (isset($this->request->post['amocrm_integration'])) {
			$settings = $this->request->post['amocrm_integration'];
		} else {
			$settings = $this->config->get('amocrm_integration');
		}
		
		$data['status'] = isset($settings['status']) ? (int)$settings['status'] : 1;
		$data['orders'] = $orders;
		$data['last_order'] = $last_order;
		$data['note_status'] = (isset($settings['note_status']) and !$settings['note_status']) ? $settings['note_status'] : 1;
		$data['product_link'] = (isset($settings['product_link']) and !$settings['product_link']) ? $settings['product_link'] : 1;	
		$data['note_template'] = (isset($settings['note_template']) and $settings['note_template']) ? $settings['note_template'] : $note_template;
		$data['lead_name'] = (isset($settings['lead_name']) and $settings['lead_name']) ? $settings['lead_name'] : 'Заказ #{{order_id}}, {{telephone}}';	
		$data['sync_comments'] = (isset($settings['sync_comments']) and !$settings['sync_comments']) ? $settings['sync_comments'] : 1; // Синхронизировать этап воронки и статус заказа
		$data['notify_status'] = isset($settings['notify_status']) ? $settings['notify_status'] : 1;
		$data['task_types'] = isset($settings['amo_data']['task_types']) ? $settings['amo_data']['task_types'] : [['id' => 0, 'name' => 'Не загружено']];
		$data['task_times'] = [
			'seconds' => 'Секунд',
			'minutes' => 'Минут',
			'hours' => 'Часов',
			'days' => 'Дней',
			'weeks' => 'Недель',
			'months' => 'Месяцев',
			'years' => 'Лет',
		];

		$task_default[] = [
			'responsible_user_id' => 0,
			'type' => 1,
			'text' => 'Дать оценку стоимости и перезвонить клиенту!',
			'deadline' => 24,
			'time' => 'hours'
		];

		$data['tasks'] = isset($settings['tasks']) ? $settings['tasks'] : $task_default;	
		$data['notify_note'] = isset($settings['notify_note']) ? $settings['notify_note'] : 1;
		$data['managers'] = isset($settings['amo_data']['managers']) ? $settings['amo_data']['managers'] : ['Не загружено'];
		$data['responsible_user_id'] = isset($settings['responsible_user_id']) ? $settings['responsible_user_id'] : [];
		$data['pipelines'] = isset($settings['amo_data']['pipelines']) ? $settings['amo_data']['pipelines'] : [0 => ['name' => 'Не загружено']];
		$data['pipeline_id'] = isset($settings['pipeline_id']) ? $settings['pipeline_id'] : array_keys($data['pipelines'])['0'];
		$data['pipeline_status'] = isset( $settings['amo_status'] ) ? $settings['amo_status'] : 0;
		$data['responsible_mode'] = isset( $settings['responsible_mode'] ) ? $settings['responsible_mode'] : 0;
		$data['oc_statuses'] = isset($settings['oc_statuses']) ? $settings['oc_statuses'] : [];
		$data['site_key'] = isset($settings['site_key']) ? $settings['site_key'] : '';
		$data['comparison'] = isset($settings['comparison']) ? $settings['comparison'] : [];

		$utm_default = [
			['name' => 'utm_content', 'field_id' => 0],
			['name' => 'utm_medium', 'field_id' => 0],
			['name' => 'utm_campaign', 'field_id' => 0],
			['name' => 'utm_source', 'field_id' => 0],
			['name' => 'utm_term', 'field_id' => 0],
			['name' => 'utm_referrer', 'field_id' => 0],
			['name' => 'roistat', 'field_id' => 0],
			['name' => 'referrer', 'field_id' => 0],
			['name' => 'openstat_service', 'field_id' => 0],
			['name' => 'openstat_campaign', 'field_id' => 0],
			['name' => 'openstat_ad', 'field_id' => 0],
			['name' => 'openstat_source', 'field_id' => 0],
			['name' => 'from', 'field_id' => 0],
			['name' => 'gclientid', 'field_id' => 0],
			['name' => '_ym_uid', 'field_id' => 0],
			['name' => '_ym_counter', 'field_id' => 0],
			['name' => 'gclid', 'field_id' => 0],
			['name' => 'yclid', 'field_id' => 0],
			['name' => 'fbclid', 'field_id' => 0]
		];

		$data['utms'] = isset($settings['utm']) ? $settings['utm'] : $utm_default;
		$data['tags'] = isset($settings['tags']) ? $settings['tags'] : ['{{store_url}}', 'myshop.ru'];
		$data['fields'] =  isset($settings['amo_data']['fields']) ? $settings['amo_data']['fields'] : ['Не загружено'];
		
		foreach(array_keys($last_order) as $key => $order_field){
			if( !is_array($last_order[$order_field]) ){
				$data['order_fields'][] = $order_field;
			}
		}

		$data['order_statuses'] = $this->model_sale_amocrm_integration->getOrderStatuses();
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/amocrm_integration.tpl', $data));
	}

    private function newOrder($order_id){
        $order_info = $this->getOrder($order_id);
		$order_fields = array_keys($order_info);
        $settings = $this->config->get('amocrm_integration');
        $comparison = $settings['comparison'];

        $lead = [
            'pipeline_id' => (int)$settings['pipeline_id'],
            'status_id' => (int)$settings['amo_status'],
            'responsible_user_id' => (int)$settings['responsible_user_id'],
        ];

		if(isset($settings['lead_name']) and $settings['lead_name'] !== ''){
			$lead_name = $settings['lead_name'];
			foreach($order_fields as $order_field){
				if( !is_array($order_info[$order_field]) ){
					$lead_name = str_replace('{{'.$order_field.'}}', $order_info[$order_field], $lead_name);
				}
			}
			$lead['name'] = $lead_name;
		}

		if(isset($settings['tags']) and $settings['tags']){
			foreach($settings['tags'] as $tag){
				foreach($order_fields as $order_field){
					if( !is_array($order_info[$order_field]) ){
						$tag = str_replace('{{'.$order_field.'}}', $order_info[$order_field], $tag);
					}
				}
				$lead['_embedded']['tags'][] = ['name' => (string)$tag];
			}
		}

        
        if($comparison){
			$note_template = $settings['note_status'] ? $settings['note_template'] : '';
            foreach($comparison as $order_field => $amo_field){
                if($amo_field !== '0'){
                    $row = explode('-', $amo_field);
                    $entry = $row['0'];
                    $field_id = $row['1'];
                    $order_value = $order_info[$order_field];

					$field_type = 'text';
					if(isset($settings['amo_data']['field_types'][$entry][$field_id])){
						$field_type = $settings['amo_data']['field_types'][$entry][$field_id];
					}
					
					if( in_array($field_type, ['date_time', 'birthday', 'date']) ){
						$order_value = strtotime($order_value);
					}elseif( in_array($field_type, ['checkbox']) ){
						$order_value = $order_value ? true : false;
					}else{
						$order_value = (string)$order_value;
					}

					if($order_value === '' or $order_value === null){
						continue;
					}

                    if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
                        ${$entry}[$field_id] = $order_value;
                    }else{
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $order_value
                                ]
                            ]
                        ];
                    }      
                }

				if( !is_array($order_info[$order_field]) ){
					$note_template = str_replace('{{'.$order_field.'}}', $order_info[$order_field], $note_template);
				}
            }

			if(isset($order_info['totals'])){
				foreach($order_info['totals'] as $total){
					$value = number_format($total['value'], 2, '.', '');
					$note_template .= $total['title'].': '.$value.' '.$order_info['currency_code'].PHP_EOL;
				}
			}

			if($settings['note_status'] and $settings['product_link'] and $order_info['products']){
				$note_template .= PHP_EOL;
				foreach($order_info['products'] as $product){
					$note_template .= $product['name'].' x'.$product['quantity'].': https://'.$_SERVER['HTTP_HOST'].'/index.php?route=product/product&product_id='.$product['product_id'] . PHP_EOL;
				}
			}

        }	
		
		if(isset($settings['utm']) and isset($order_info['utm'])){
			$utms = $order_info['utm'];
			foreach($settings['utm'] as $utm){
				if ($utm['field_id'] !== '0') {
					$_data = explode('-', $utm['field_id']);
					$entry = $_data['0'];
					$field_id = $_data['1'];

					if( !isset($utms[$utm['name']]) ){
						continue;
					}

					if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
						${$entry}[$field_id] = $utms[$utm['name']];
					}else{
						${$entry}['custom_fields_values'][] = [
							'field_id' => (int)$field_id,
							'values' => [
								[
									'value' => (string)$utms[$utm['name']]
								]
							]
						];
					}
				}
			}
		}

		$tasks_data = $settings['tasks'];
		$tasks = [];
		if( $tasks_data ){
			$current_datetime = date('Y-m-d H:i:s');
			foreach($tasks_data as $task_data){
				$deadline = $task_data['deadline'] === '' ? 24 : $task_data['deadline'];
				$tasks[] = [
                    'responsible_user_id' => (int)$task_data['responsible_user_id'],
                    'task_type_id' => (int)$task_data['type'],
                    'text' => (string)$task_data['text'],
                    'complete_till' => strtotime( $current_datetime . ' +' . $deadline . ' ' . $task_data['time'] )
				];
			}
		}

		$products = [];
		if(isset($order_info['products'])){
			$products = $order_info['products'];
		}

        return json_encode([
            'lead'     => isset($lead) ? $lead : [],
            'contact'  => isset($contact) ? $contact : [],
            'note'     => isset($note_template) ? $note_template : [],
            'tasks'    => $tasks,
			'products' => $products,
        ]);

    }

	public function export(){
		if ( ($this->request->server['REQUEST_METHOD'] == 'POST' and $this->request->post['orders']) ) {
			$return = [];
			foreach($this->request->post['orders'] as $order_id){
                $order['action'] = 'newOrderV2';
                $order['url'] = $_SERVER['HTTP_HOST'];
                $order['data'] = $this->newOrder($order_id);
				$order['order_id'] = $order_id;
                $curl = curl_init();
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/opencart/ajax');
                curl_setopt($curl, CURLOPT_HEADER, false);
                curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
                curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($order));
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
                $output = curl_exec($curl);
                curl_close($curl);
				$output = json_decode($output, true);
				$output['order_id'] = $order_id;
				$return[] = $output;
			}
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput( json_encode($return) );
		}
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/amocrm_integration')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		return !$this->error;
	}

	private function getAmoCF(){
		$data = ['action' => 'getAmoCF', 'url' => $_SERVER['HTTP_HOST']];
		$ch = curl_init('https://devamo.ru/opencart/ajax');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data)); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_HEADER, false);
		$output = curl_exec($ch);
		$output = json_decode($output, true);
		curl_close($ch);
		return isset($output['settings']) ? $output['settings'] : false;
	}

	private function getOrder($order_id){
		$this->load->model('sale/amocrm_integration');
		$order_utm = $this->model_sale_amocrm_integration->getUtmFromOrder($order_id);
		$order_info = $this->model_sale_amocrm_integration->getOrder($order_id);
		$data['order_id'] = $order_id;
		$data['store_id'] = $order_info['store_id'];
		$data['store_url'] = ($_SERVER['HTTP_HOST']);

		$data['customer'] = $order_info['customer'];
		$data['customer_id'] = $order_info['customer_id'];
		$data['customer_group_id'] = $order_info['customer_group_id'];
		$data['firstname'] = $order_info['firstname'];
		$data['lastname'] = $order_info['lastname'];
		$data['email'] = $order_info['email'];
		$data['telephone'] = $order_info['telephone'];
		$data['fax'] = $order_info['fax'];
		$data['account_custom_field'] = $order_info['custom_field'];

		$data['addresses'] = $this->model_sale_amocrm_integration->getAddresses($order_info['customer_id']);

		$data['payment_firstname'] = $order_info['payment_firstname'];
		$data['payment_lastname'] = $order_info['payment_lastname'];
		$data['payment_company'] = $order_info['payment_company'];
		$data['payment_address_1'] = $order_info['payment_address_1'];
		$data['payment_address_2'] = $order_info['payment_address_2'];
		$data['payment_city'] = $order_info['payment_city'];
		$data['payment_postcode'] = $order_info['payment_postcode'];
		$data['payment_country_id'] = $order_info['payment_country_id'];
		$data['payment_country'] = $order_info['payment_country'];
		$data['payment_zone_id'] = $order_info['payment_zone_id'];
		$data['payment_zone'] = $order_info['payment_zone'];
		$data['payment_custom_field'] = $order_info['payment_custom_field'];
		$data['payment_method'] = $order_info['payment_method'];
		$data['payment_code'] = $order_info['payment_code'];

		$data['shipping_firstname'] = $order_info['shipping_firstname'];
		$data['shipping_lastname'] = $order_info['shipping_lastname'];
		$data['shipping_company'] = $order_info['shipping_company'];
		$data['shipping_address_1'] = $order_info['shipping_address_1'];
		$data['shipping_address_2'] = $order_info['shipping_address_2'];
		$data['shipping_city'] = $order_info['shipping_city'];
		$data['shipping_postcode'] = $order_info['shipping_postcode'];
		$data['shipping_country_id'] = $order_info['shipping_country_id'];
		$data['shipping_country'] = $order_info['shipping_country'];
		$data['shipping_zone'] = $order_info['shipping_zone'];
		$data['shipping_zone_id'] = $order_info['shipping_zone_id'];
		$data['shipping_custom_field'] = $order_info['shipping_custom_field'];
		$data['shipping_method'] = $order_info['shipping_method'];
		$data['shipping_code'] = $order_info['shipping_code'];
		$data['total'] = number_format($order_info['total'], 2, '.', '');	

		// Products
		$data['products'] = array();

		$products = $this->model_sale_amocrm_integration->getOrderProducts($order_id);

		foreach ($products as $product) {
			$data['products'][] = array(
				'product_id' => $product['product_id'],
				'name'       => $product['name'],
				'model'      => $product['model'],
				'option'     => $this->model_sale_amocrm_integration->getOrderOptions($order_id, $product['order_product_id']),
				'quantity'   => $product['quantity'],
				'price'      => number_format($product['price'], 2, '.', ''),
				'total'      => number_format($product['total'], 2, '.', ''),
				'reward'     => $product['reward']
			);
		}

		// Vouchers
		$data['order_vouchers'] = $this->model_sale_amocrm_integration->getOrderVouchers($order_id);

		$data['coupon'] = '';
		$data['voucher'] = '';
		$data['reward'] = '';

		$data['order_totals'] = array();

		$order_totals = $this->model_sale_amocrm_integration->getOrderTotals($order_id);

		foreach ($order_totals as $order_total) {
			// If coupon, voucher or reward points
			$start = strpos($order_total['title'], '(') + 1;
			$end = strrpos($order_total['title'], ')');

			if ($start && $end) {
				$data[$order_total['code']] = substr($order_total['title'], $start, $end - $start);
			}
		}

		$data['order_status_id'] = $order_info['order_status_id'];
		$data['comment'] = $order_info['comment'];
		$data['affiliate_id'] = $order_info['affiliate_id'];
		$data['affiliate'] = $order_info['affiliate_firstname'] . ' ' . $order_info['affiliate_lastname'];
		$data['currency_code'] = $order_info['currency_code'];
		$data['invoice_prefix'] = $order_info['invoice_prefix'];

		if ($order_info['invoice_no']) {
			$data['invoice_no'] = $order_info['invoice_prefix'] . $order_info['invoice_no'];
		} else {
			$data['invoice_no'] = '';
		}

		$totals = $this->model_sale_amocrm_integration->getOrderTotals($order_id);

		foreach ($totals as $total) {
			$data['totals'][] = $total;
		}

		$data['utm'] = $order_utm;
		$data['date_added'] = $order_info['date_added'];
		$data['date_modified'] = $order_info['date_modified'];
		return $data;
	}

	public function order(){
		if( $this->request->server['REQUEST_METHOD'] === 'POST' and $this->request->post['order_id'] ){
			$data = ['status' => 1, 'order' => $this->getOrder( $this->request->post['order_id'] )];
		}else{
			$data = ['status' => 0];
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput( json_encode( $data ) );
	}

	public function install(){
		$this->load->model('sale/amocrm_integration');
		$this->load->model('extension/event');
		$this->load->model('setting/setting');
 		$this->model_extension_event->addEvent(
			'amoCRM-integration',
			'pre.order.history.add',
			'api/amocrm_integration'
		);
		if($this->request->post['amocrm_integration']['amo_data'] = $this->getAmoCF() ){
			$this->model_setting_setting->editSetting('amocrm_integration', $this->request->post);
		}
		$this->model_sale_amocrm_integration->creatTableUtm();
	}

	public function uninstall() {
	    $this->load->model('sale/amocrm_integration');
		$this->load->model('extension/event');
		$this->load->model('setting/setting');
		$this->model_extension_event->deleteEvent('amoCRM-integration');
		$this->model_setting_setting->deleteSetting('amocrm_integration');
		$this->model_sale_amocrm_integration->deleteTableUtm();
	}
}