<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <button type="button" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-success" id="save"><i class="fa fa-save"></i></button>
                <button type="submit" form="form-amocrm_integration" data-toggle="tooltip" onclick="$('form.form-horizontal').attr('action','<?php echo $action; ?>&refresh');" title="Обновить данные amoCRM" class="btn btn-warning" id="refresh"><i class="fa fa-refresh"></i></button>
                <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-sign-out"></i></a>
            </div>
            <h1><?php echo $heading_title; ?></h1>
            <ul class="breadcrumb">
                <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                <?php } ?>
            </ul>
        </div>
    </div>
    <div class="container-fluid">
        <?php if ($error_warning) { ?>
        <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php } ?>
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
            </div>
            <div class="panel-body">
                <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-amocrm_integration" class="form-horizontal">

                    <ul class="nav nav-tabs">
                        <li><a href="#tab-header" data-toggle="tab">Основное</a></li>
                        <li><a href="#tab-constructor" data-toggle="tab">Конструктор</a></li>
                        <li><a href="#tab-note" data-toggle="tab">Примечание</a></li>
                        <li><a href="#tab-task" data-toggle="tab">Задачи</a></li>
                        <li><a href="#tab-utm" data-toggle="tab">UTM-метки</a></li>
                        <li><a href="#tab-tags" data-toggle="tab">Теги</a></li>
                        <li><a href="#tab-export" data-toggle="tab">Экспорт заказов</a></li>
                    </ul>

                    <div class="tab-content">
                        <div class="tab-pane" id="tab-header">

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-name">Статус модуля</label>
                                <div class="col-sm-4">
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[status]" value="1" <?php echo  $status ? 'checked' : ''; ?> > <?php echo $text_enabled; ?></label>
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[status]" value="0" <?php echo !$status ? 'checked' : ''; ?> > <?php echo $text_disabled; ?></label>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-auth">Авторизация в amoCRM</label>
                                <div class="col-sm-4">
                                    <a href="https://devamo.ru/opencart/button" class="btn btn-primary" target="_blank">Перейти</a>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="select-lead_name">Название сделки</label>
                                <div class="col-sm-2">
                                    <input type="text" name="amocrm_integration[lead_name]" value="<?php echo $lead_name ?>" class="form-control">
                                </div>
                                <div class="col-sm-8 control-label text-left">
                                    Можно использовать произвольный текст и любые "Поля заказа" из вкладки "Конструктор"
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="select-responsible_user_id">Ответственный по умолчанию</label>
                                <div class="col-sm-2">
                                    <select name="amocrm_integration[responsible_user_id]" id="select-responsible_user_id" class="form-control">
									<?php if($managers){ ?>
										<?php foreach($managers as $ID => $manager){ ?>
											<option value="<?php echo $ID ?>" <?php echo $ID == $responsible_user_id ? 'selected' : ''; ?>><?php echo $manager ?></option>
										<?php } ?>
									<?php } ?>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="select-pipeline_id">Воронка по умолчанию</label>
                                <div class="col-sm-2">
                                    <select name="amocrm_integration[pipeline_id]" id="select-pipeline_id" class="form-control">
									<?php if($pipelines){ ?>
										<?php foreach($pipelines as $ID => $pipeline){ ?>
											<option value="<?php echo $ID ?>" <?php echo ($ID == $pipeline_id) ? 'selected' : ''; ?>><?php echo $pipeline['name'] ?></option>
										<?php } ?>
									<?php } ?>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="select-amo_status">Этап воронки по умолчанию</label>
                                <div class="col-sm-2">
                                    <select name="amocrm_integration[amo_status]" id="select-amo_status" class="form-control">
                                        <option value="0">Не загужено</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-sync_statuses">Синхронизировать этап воронки и статус заказа opencart</label>
                                <div class="col-sm-4">
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[sync_statuses]" value="1" <?php echo $sync_statuses ? 'checked' : ''; ?> > Да</label>
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[sync_statuses]" value="0" <?php echo !$sync_statuses ? 'checked' : ''; ?> > Нет</label>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-notify_note">Прикреплять товары</label>
                                <div class="col-sm-4">
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[products]" value="1" <?php echo $products ? 'checked' : ''; ?> > Да</label>
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[products]" value="0" <?php echo !$products ? 'checked' : ''; ?> > Нет</label>
                                </div>
                            </div>
                            
                            <?php foreach($order_statuses as $oc_status){ ?>
                            <div class="form-group">                                

                                    <div class="col-sm-2">
                                            <input type="text" value="<?php echo $oc_status['name'] ?>" readonly class="form-control">
                                    </div>

                                    <div class="col-sm-2">
                                        <select name="amocrm_integration[oc_statuses][<?php echo $oc_status['order_status_id'] ?>]" id="oc_status_<?php echo $oc_status['order_status_id'] ?>" class="form-control">
                                            <option value="0" selected="">Не загружено</option>
                                        </select>
                                    </div>

                            </div>
                            <?php } ?>                            

                        </div>

                        <div class="tab-pane" id="tab-note">
                           
                            <div class="form-group">
                                <label class="col-sm-2 control-label">Создавать примечание в сделке</label>
                                <div class="col-sm-2">
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[note_status]" value="1" <?php echo  $note_status ? 'checked' : ''; ?> > Да</label>
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[note_status]" value="0" <?php echo !$note_status ? 'checked' : ''; ?> > Нет</label>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-name">Добавлять ссылку на товары</label>
                                <div class="col-sm-4">
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[product_link]" value="1" <?php echo $product_link ? 'checked' : ''; ?> > Да</label>
                                    <label class="radio-inline"><input type="radio" name="amocrm_integration[product_link]" value="0" <?php echo !$product_link ? 'checked' : ''; ?> > Нет</label>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label">Шаблон примечания</label>
                                <div class="col-sm-4">
                                    <textarea id="note_template" name="amocrm_integration[note_template]" rows="15" class="form-control"><?php echo $note_template ?></textarea>
                                </div>

                                <div class="col-sm-6">
                                    <div class="control-label text-left"><strong>Поля заказа</strong></div>
                                    <div class="order_tags">
                                        <span class="btn-xs btn-outline-primary"><?php echo implode('</span>, <span class="btn-xs btn-outline-primary">', $order_fields) ?></span>
                                    </div>
                                </div>

                            </div>

                        </div>

                        <div class="tab-pane" id="tab-task">

                            <div class="form-group">

                                <div class="tastk_titles">
                                    <label class="col-sm-2 control-label text-left">Ответственный</label>
                                    <label class="col-sm-2 control-label text-left">Тип задачи</label>
                                    <label class="col-sm-3 control-label text-left">Описание</label>
                                    <label class="col-sm-2 control-label text-left">Дедлайн через</label>
                                    <label class="col-sm-2 control-label text-left">&nbsp;</label>
                                    <label class="col-sm-1 control-label text-left"></label>
                                </div>
                                <div class="clearfix"></div>
                                <hr>

                                <div class="tasks col-sm-12">

                                    <?php if($tasks){ ?>
                                        <?php foreach($tasks as $task_id => $task){ ?>
                                        <div id="task_<?php echo $task_id ?>" class="form-group task">
                                            <div class="col-sm-2">
                                                <select class="form-control" name="amocrm_integration[tasks][<?php echo $task_id ?>][responsible_user_id]" id="select-responsible_user_id_task">
                                                <?php if($managers){ ?>
                                                    <?php foreach($managers as $ID => $manager){ ?>
                                                        <option value="<?php echo $ID ?>" <?php echo $ID == $task['responsible_user_id'] ? 'selected' : ''; ?>><?php echo $manager ?></option>
                                                    <?php } ?>
                                                <?php } ?>
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                                <select name="amocrm_integration[tasks][<?php echo $task_id ?>][type]" id="select-task_type" class="form-control">
                                                <?php if($task_types){ ?>
                                                    <?php foreach($task_types as $tasktype){ ?>
                                                    <option value="<?php echo $tasktype['id'] ?>" <?php echo $tasktype['id'] == $task['type'] ? 'selected' : ''; ?>><?php echo $tasktype['name'] ?></option>
                                                    <?php } ?>
                                                <?php } ?>
                                                </select>
                                            </div>

                                            <div class="col-sm-3">
                                                <input name="amocrm_integration[tasks][<?php echo $task_id ?>][text]" value="<?php echo $task['text'] ?>" class="form-control">
                                            </div>

                                            <div class="col-sm-2">
                                                <input name="amocrm_integration[tasks][<?php echo $task_id ?>][deadline]" value="<?php echo $task['deadline'] ?>" class="form-control">
                                            </div>

                                            <div class="col-sm-2">
                                                <select name="amocrm_integration[tasks][<?php echo $task_id ?>][time]" id="select-task_time" class="form-control">
                                                    <?php foreach($task_times as $task_time_value => $task_time_name){ ?>
                                                    <option value="<?php echo $task_time_value ?>" <?php echo $task_time_value == $task['time'] ? 'selected' : '' ?>><?php echo $task_time_name ?></option>
                                                    <?php } ?>
                                                </select>
                                            </div>
                                            
                                            <div class="col-sm-1"><button type="button" onclick="$('#task_<?php echo $task_id ?>').remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>

                                        </div>
                                        <?php } ?>
                                    <?php } ?>

                                </div>

                                <div class="clearfix"></div>

                                <div class="col-sm-1 col-sm-offset-11">
                                    <button type="button" id="newTask" class="btn btn-primary"><i class="fa fa-plus-circle"></i></button>
                                </div>

                            </div>

                        </div>

                        <div class="tab-pane" id="tab-constructor">
						
                            <div class="form-group">
                                <div class="form-group">
                                    <label class="col-sm-2 control-label" for="select-order">Последние 10 заказов</label>
                                    <div class="col-sm-2">
										<select name="orders" id="select-order" class="form-control">
											<?php foreach($orders as $ID => $order){ ?>
												<option value="<?php echo $order['order_id'] ?>">Заказ #<?php echo $order['order_id'] ?> (<?php echo $order['customer'] ?>)</option>
											<?php } ?>
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-sm-2 control-label">Поле заказа</label>
                                <label class="col-sm-2 control-label text-left">Поле amoCRM</label>
                                <label class="col-sm-2 control-label text-left">Значение поля заказа</label>
                            </div>

							<?php if($order_fields){ ?>

								<?php foreach($order_fields as $order_field){ ?>
								<div class="form-group">
									<label class="col-sm-2 control-label" for="select-<?php echo $order_field ?>"><?php echo $order_field; ?></label>
									<div class="col-sm-2">
										<select name="amocrm_integration[comparison][<?php echo $order_field ?>]" id="select-utm_<?php echo $order_field ?>" class="form-control">
										<?php if($fields){ ?>
											<?php foreach($fields as $ID => $field){ ?>
												<option value="<?php echo $ID ?>" <?php echo (isset($comparison[$order_field]) and $comparison[$order_field] === $ID) ? 'selected' : '' ?> ><?php echo $field ?></option>
											<?php } ?>
										<?php } ?>
										</select>	
									</div>
									<label class="col-sm-2 control-label text-left" for="select-<?php echo $order_field ?>" id="order_field_<?php echo $order_field ?>">
                                        <?php echo isset($last_order[$order_field]) ? $last_order[$order_field] : '' ?>
                                    </label>
								</div>
								<?php } ?>
							
							<?php } ?>
						</div>

                        <div class="tab-pane" id="tab-utm">

							<div id="utm_row">

								<?php if($utms) { ?>
									<?php foreach ($utms as $key => $utm) { ?>
										<div id="menu_link<?php echo $key; ?>">
											<div class="col-sm-2">
												<input type="text" name="amocrm_integration[utm][<?php echo $key ?>][name]" value="<?php echo $utm['name'] ?>" placeholder="Метка" class="form-control" />
											</div>
											<div class="col-sm-2">

												<select name="amocrm_integration[utm][<?php echo $key ?>][field_id]" id="select-utm_<?php echo $key ?>" class="form-control">
												<?php if($fields){ ?>
													<?php foreach($fields as $ID => $field){ ?>
														<option value="<?php echo $ID ?>" <?php echo $ID === $utm['field_id'] ? 'selected' : ''; ?>><?php echo $field ?></option>
													<?php } ?>
												<?php } ?>
												</select>	

											</div>
											<div class="col-sm-1"><button type="button" onclick="$('#menu_link<?php echo $key; ?>').remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>
										</div>

									<?php } ?>
								<?php } ?>

							</div>
							<div class="col-sm-1 col-sm-offset-4"><button type="button" onclick="addRowMenu();" data-toggle="tooltip" title="" class="btn btn-primary" data-original-title="Добавить"><i class="fa fa-plus-circle"></i></button></div>
						</div>

                        <div class="tab-pane" id="tab-tags">
                            <label class="col-sm-8 control-label text-left font-weight-400">Можно использовать произвольный текст и любые "Поля заказа" из вкладки "Конструктор"</label>
                            <div class="clearfix"></div>
                            <hr
                            >
                            <div id="tags_row">
                                <?php if($tags) { ?>
                                    <?php foreach ($tags as $tag) { ?>
                                        <div class="menu_tag">
                                            <div class="col-sm-2">
                                                <input type="text" name="amocrm_integration[tags][]" value="<?php echo $tag ?>" placeholder="тег" class="form-control" />
                                            </div>
                                            <div class="col-sm-1"><button type="button" onclick="$(this).parent().parent().remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>
                                        </div>
                                    <?php } ?>
                                <?php } ?>
                            </div>
							<div class="col-sm-1 col-sm-offset-2"><button type="button" onclick="addRowTag();" data-toggle="tooltip" title="" class="btn btn-primary" data-original-title="Добавить"><i class="fa fa-plus-circle"></i></button></div>
                        </div>

                        <div class="tab-pane" id="tab-export">

                            <div class="table-responsive">
                                <table class="table table-bordered table-hover order">
                                    <thead>
                                    <tr>
                                        <td style="width: 1px;" class="text-center">
                                            <input type="checkbox" onclick="$('input[name^=orders]').prop('checked', this.checked);">
                                        </td>
                                        <td class="text-right">№ Заказа</td>
                                        <td class="text-left">Клиент</td>
                                        <td class="text-left">Статус</td>
                                        <td class="text-right">Итого</td>
                                        <td class="text-left">Дата добавления</td>
                                        <td class="text-left">Дата изменения</td>
                                    </tr>
                                    </thead>
                                    <tbody>
                                        <?php if($orders){ ?>
                                            <?php foreach($orders as $order){ ?>
                                            <tr>
                                                <td class="text-center">
                                                    <input type="checkbox" name="orders[]" value="<?php echo $order['order_id'] ?>">
                                                </td>
                                                <td class="text-right"><?php echo $order['order_id'] ?></td>
                                                <td class="text-left"><?php echo $order['customer'] ?></td>
                                                <td class="text-left"><?php echo $order['order_status'] ?></td>
                                                <td class="text-right"><?php echo ceil($order['total']) ?> <?php echo $order['currency_code'] ?></td>
                                                <td class="text-left"><?php echo date('d.m.Y H:i:s', strtotime($order['date_added'])) ?></td>
                                                <td class="text-left"><?php echo date('d.m.Y H:i:s', strtotime($order['date_modified'])) ?></td>
                                            </tr>
                                            <?php } ?>
                                        <?php } ?>
                                    </tbody>
                                </table>

                                <div class="pagination">
                                    <div class="text-left"><?php echo $pagination; ?></div>
                                    <div class="text-right"><?php echo $results; ?></div>
                                </div>


                                
                                <div class="progress-container">
                                    <div class="col-sm-10">
                                        <div class="progress">
                                            <div class="progress-bar progress-bar-success" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="min-width: 2em; width: 0%;">0%</div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2 text-right">
                                        <button type="button" id="export" class="btn btn-primary">Экспортировать</button>
                                    </div>
                                </div>
                                


                            </div>



                        </div>

                    </div>
                </form>



            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
<!--
$(document).on('click', '.pagination a', function(e){
    e.stopPropagation();
    e.preventDefault();
    var href = $(this).attr('href');
    $('#tab-export').load(href + ' #tab-export>*');
});

$('#save').on('click', function(){
    var tab = $('.tab-content .tab-pane.active').attr('id');
    var action = '<?php echo $action; ?>&apply&tab=' + tab;
    $('form.form-horizontal').attr('action', action).submit();
});

$('#refresh').on('click', function(){
    var tab = $('.tab-content .tab-pane.active').attr('id');
    var action = '<?php echo $action; ?>&refresh&tab=' + tab;
    $('form.form-horizontal').attr('action', action).submit();
});

$('.nav-tabs a[href=#<?php echo $tab ?>]').parent().addClass('active');
$('#<?php echo $tab ?>').addClass('active');


var last_task_id = 0;
$(document).on('click', '#newTask', function(){
    last_task_id++;
    var task = '<div id="task_'+last_task_id+'" class="form-group task">';

            task += '<div class="col-sm-2">';
                task += '<select class="form-control" name="amocrm_integration[tasks]['+last_task_id+'][responsible_user_id]" id="select-responsible_user_id_task">';
                <?php if($managers){ ?>
                    <?php foreach($managers as $ID => $manager){ ?>
                        task += '<option value="<?php echo $ID ?>"><?php echo $manager ?></option>';
                    <?php } ?>
                <?php } ?>
                task += '</select>';
            task += '</div>';

            task += '<div class="col-sm-2">';
                task += '<select name="amocrm_integration[tasks]['+last_task_id+'][type]" id="select-task_type" class="form-control">';
                <?php if($task_types){ ?>
                    <?php foreach($task_types as $tasktype){ ?>
                    task += '<option value="<?php echo $tasktype['id'] ?>"><?php echo $tasktype['name'] ?></option>';
                    <?php } ?>
                <?php } ?>
                task += '</select>';
            task += '</div>';

            task += '<div class="col-sm-3">';
                task += '<input name="amocrm_integration[tasks]['+last_task_id+'][text]" value="Дать оценку стоимости и перезвонить клиенту!" class="form-control">';
            task += '</div>';

            task += '<div class="col-sm-2">';
                task += '<input name="amocrm_integration[tasks]['+last_task_id+'][deadline]" value="1" class="form-control">';
            task += '</div>';

            task += '<div class="col-sm-2">';
                task += '<select name="amocrm_integration[tasks]['+last_task_id+'][time]" id="select-task_time" class="form-control">';
                    <?php foreach($task_times as $task_time_value => $task_time_name){ ?>
                    task += '<option value="<?php echo $task_time_value ?>" <?php echo $task_time_value == 'days' ? 'selected' : '' ?>><?php echo $task_time_name ?></option>';
                    <?php } ?>
                task += '</select>';
            task += '</div>';
            //$(\'#menu_link' + i + '\')
            task += '<div class="col-sm-1"><button type="button" onclick="$(\'#task_' + last_task_id + '\').remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>';


        task += '</div>';
        
    $('.tasks').append(task);

});

$(document).on('click', '#export', function(){
    var orders = $('.order input[type=checkbox]:checked');
    $('.tab-content .progress-bar').css('width', '0%').text('0%');
    if(orders.length){
        $.ajax({
            url : '/admin/index.php?route=extension/module/amocrm_integration/export&token=<?php echo $token ?>',
            type: 'post',
            data: $('.order input[type=checkbox]:checked'),
            dataType: 'json',
            success: function(data) {
                if(data.length){
                    $('.tab-content .progress-bar').css('width', '100%').text('100%');
                }
            },
            error: function(xhr, ajaxOptions, thrownError) {
                alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });
    }else{
        $('.tab-content .progress-bar').css('width', '0%').text('0%');
    }


});

var order_fields = <?php echo json_encode($order_fields) ?>;
var pipelines = <?php echo json_encode($pipelines); ?>;
var pipeline_id = <?php echo $pipeline_id; ?>;
var pipeline_status  = <?php echo $pipeline_status; ?>;
var order_statuses = <?php echo json_encode($order_statuses) ?>;
var oc_statuses = <?php echo json_encode($oc_statuses) ?>;

changePipeline(pipeline_id, pipeline_status);

$('#select-pipeline_id').on('change', function(){
    var pipeline_id = $(this).val(); 
    changePipeline(pipeline_id, pipeline_status);
});

function changePipeline(pipeline_id = false, status = false){
    var options = '';
    options += '<option value="0">Не выбрано</option>'
    $.each(pipelines[pipeline_id]['statuses'], function(status_id, value) {
        options += '<option value="'+status_id+'">'+value.name+'</option>';
    }); 

    $('#select-amo_status').html(options);

    if(status){
        $('#select-amo_status option[value='+status+']').attr('selected', 'selected');
    }

    $.each(order_statuses, function(index, status){
        $('#oc_status_'+status.order_status_id).html(options);
        if(status.order_status_id in oc_statuses && oc_statuses[status.order_status_id] !== '' ){
            $('#oc_status_'+status.order_status_id+' option[value='+oc_statuses[status.order_status_id]+']').attr('selected', 'selected');
        }

    });
}

$('.amocrm-integration .settings input[type=checkbox]').on('change', function(){
    $('#publishing-action input[type=submit]').click();
});


    ////////////
$(document).on('change', '#select-order', function(){
    var order_id = $(this).val();

    var data = [];
    data.push({name: "order_id", value: order_id});

    $.ajax({
        url : '/admin/index.php?route=extension/module/amocrm_integration/order&token=<?php echo $token ?>',
        type: 'POST',
        dataType: 'json',
        data: data,
        success:function(data){
            if(data.status){
                
                $.each(order_fields, function(index, order_field){
                    $('#order_field_'+order_field).text(data.order[order_field]);
                });

            }else{
                var error = '<span style="color:red">'+data.message+'</span>';
                $('#result').html(error);
            }
            btn.removeAttr('disabled');
            btn.text(btn_text);
        }
    });
});

$(document).on('click', '.order_tags span', function(){
    var oldValue = $('#note_template').val();
    $('#note_template').val( oldValue + '{{' + $(this).text() + '}}' );
});

var i = <?php echo count($utms) ?>;

function addRowMenu() {
    i++;
	var fields = '';
		fields += '<select name="amocrm_integration[utm][<?php echo $key ?>][field_id]" id="select-utm_<?php echo $key ?>" class="form-control">';
		<?php if($fields){ ?>
			<?php foreach($fields as $ID => $field){ ?>
				fields += '<option value="<?php echo $ID ?>" <?php echo ($ID == $utm['field_id']) ? 'selected' : ''; ?>><?php echo $field ?></option>';
			<?php } ?>
		<?php } ?>
		fields += '</select>';
    html = '<div id="menu_link' + i + '" class="">';
    html += '   <div class="col-sm-2"><input type="text" name="amocrm_integration[utm]['+i+'][name]" value="" placeholder="Метка" class="form-control" /></div>';
    html += '   <div class="col-sm-2">'+fields+'</div>';
    html += '   <div class="col-sm-1"><button type="button" onclick="$(\'#menu_link' + i + '\').remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>';
    html += '</div>';
    $('#utm_row').append(html);    
}

function addRowTag() {
        html = '<div class="menu_tag">';
        html += '   <div class="col-sm-2">';
        html += '       <input type="text" name="amocrm_integration[tags][]" value="" placeholder="тег" class="form-control">';
        html += '   </div>';
        html += '   <div class="col-sm-1"><button type="button" onclick="$(this).parent().parent().remove();" data-toggle="tooltip" title="" class="btn btn-danger" data-original-title="Удалить"><i class="fa fa-minus-circle"></i></button></div>';
        html += '</div>';
    $('#tags_row').append(html);    
}


//
-->
</script>

<style>
.table thead > tr > td, .table tbody > tr {
    font-family: 'Open Sans', sans-serif;
    font-size: 12px !important;
}

[id^="row_link"],
[id^="menu_link"],
.menu_tag {
    margin-bottom: 10px;
    position: relative;
    display: inline-block;
    width: 100%;
}
.form-horizontal .control-label.text-left{
    text-align: left;
}
.form-horizontal .control-label.text-left:before {
    display: none;
}

.btn-outline-primary {
    color: #007bff;
    border: 1px solid #007bff;
    cursor:pointer;
    display: inline-block;
    margin-bottom: 5px;
}

.btn-outline-primary:hover {
    color: #fff;
    background-color: #007bff;
    border-color: #007bff;
}

.ctrl-laberl{
    text-align: right;
    margin-bottom: 0;
    padding-top: 9px;
}
#newTask{
    margin-top:15px;
}
.pagination{
	display: flex;
	flex-direction: row;
	flex-wrap: nowrap;
	justify-content: space-between;
	align-items: center;
	align-content: stretch;
    margin-bottom: 15px;
}

.tasks .form-group + .form-group {
    border: none;
}
.progress-container {
    display: block;
}
.progress-container .progress {
    margin-top: 10px;
}
.font-weight-400{
    font-weight: 400;
}
</style>
<?php echo $footer; ?>
